/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: USI_TWI_Master.h
* ߲		: IAR EWAAVR 4.10B
* 			: $Revision: 1.81 $
* t			: $Date: 18.03.2005 $
* XV		: $Author: LTWA, KMe $
*
* xҰ		: avr@atmel.com
*
* x޲	: {ATmega169pɏĂ܂B
*
* pLq		: AVR310 - TWI呕uƂĂUSI̎g
*
* 			: USIbƂĎgpTWI呕u̎łB
*				  ѓ̗BTWI呕ułAVRƉ肵A]ĕ呕u
*				  тgp邱Ƃ͂ł܂B
* g		: USI_TWI_Master_Initialize()֐ĂяoƂɂUSI
*				  ĂB̌Aү/ްUSI_TWI_Start_
*				  Transceiver_With_Data()֐gp޽őM܂B
*				  MsԂꍇǍɎš]邽߂
*				  USI_TWI_Get_Status_InfogpĂB
*
****************************************************************************/

#include <ioavr.h>

// * ` *

// ݸތx`
#define TWI_FAST_MODE

#define SYS_CLK		1000.0							// (kHz)

#ifdef TWI_FAST_MODE								// (SCL=100`400kHz)ݸތx
  #define T2_TWI	((SYS_CLK *1300) /1000000) +1	// ŏLowԎ(>1.3s)
  #define T4_TWI	((SYS_CLK * 600) /1000000) +1	// ŏHighԎ(>0.6s)

#else												// W(SCL100kHz)ݸތx
  #define T2_TWI	((SYS_CLK *4700) /1000000) +1	// ŏLowԎ(>4.7s)
  #define T4_TWI	((SYS_CLK *4000) /1000000) +1	// ŏHighԎ(>4.0s)
#endif

// ސ`(ߍ폜ŋ)
//#define PARAM_VERIFICATION	// ]ޯ̧غސ
//#define NOISE_TESTING			// \ʏoސ
//#define SIGNAL_VERIFY			// (đ)Jn/~غސ

// USI_TWIүށA׸ށAޯĎՕl
//#define SUCCESS	7
//#define MSG		0
/****************************************************************************
  ޯĂ޲Ă̒`
****************************************************************************/
#define TWI_READ_BIT	0		// ڽ ߹ēR/WޯĈʒu
#define TWI_ADR_BITS	1		// ڽ ߹ē̏]uڽLSBʒu
#define TWI_NACK_BIT	0		// (N)ACKޯĒl

#define USI_TWI_NO_DATA				0x00	// ]ޯ̧
#define USI_TWI_DATA_OUT_OF_BOUND	0x01	// ]ޯ̧SRAMԊO
#define USI_TWI_UE_START_CON		0x02	// \(đ)Jn
#define USI_TWI_UE_STOP_CON			0x03	// \ʒ~
#define USI_TWI_UE_DATA_COL			0x04	// \ް()
#define USI_TWI_NO_ACK_ON_DATA		0x05	// ]uSްɖ
#define USI_TWI_NO_ACK_ON_ADDRESS	0x06	// ]uڽɖ
#define USI_TWI_MISSING_START_CON	0x07	// (đ)Jn޽Ŗo
#define USI_TWI_MISSING_STOP_CON	0x08	// ~޽Ŗo

// ޲ˑ`(ATmega169p)
#define DDR_USI			DDRE
#define PORT_USI		PORTE
#define PIN_USI			PINE
#define PORT_USI_SDA	PORTE5
#define PORT_USI_SCL	PORTE4
#define PIN_USI_SDA		PINE5
#define PIN_USI_SCL		PINE4

// * ^錾 *

void              USI_TWI_Master_Initialize( void );
__x unsigned char USI_TWI_Start_Transceiver_With_Data( unsigned char * , unsigned char );
unsigned char     USI_TWI_Get_State_Info( void );

#pragma vector = USI_STRT_vect
__interrupt void USI_START_ISR(void);
