/******************************************************************************
*
* Atmel Corporation
*
* ̧			: USI_TWI_Slave.c
* ߲		: IAR EWAAVR 4.11A
* 			: $Revision: 1.71 $
* t			: $Date: 27.07, 2005$
* XV		: $Author: LTWA, KMe $
*
* xҰ		: avr@atmel.com
*
* x޲	: USISĂ޲gp\łB
*				  ̗ATtiny25/45/85pɏĂ܂B
*
* pLq		: AVR441: ̧ݐ(AVR312:I2C]uƂĂUSI̎g)
*
* 			: USI_TWI_receiverUSI_TWI_transmitterp̊֐
*
******************************************************************************/

//#include <ioavr.h>
#include <inavr.h>

//#include "iotiny45.h"
#include "USI_TWI_Slave.h"

//	* ÓIϐ *

static unsigned char TWI_slaveAddress;

static unsigned char TWI_RxBuf[TWI_RX_BUFFER_SIZE];
static unsigned char TWI_TxBuf[TWI_TX_BUFFER_SIZE];

union USI_TWI_statusReg USI_TWI_statusReg = {0};		// USI_TWI޲(USI_TWI_S_statusRegisterUSI_TWI_Slave_config.hŒ`)

struct USI_TWI_state									// ׸ނێ޲
{
  unsigned char addressMode:1;							// SLA+R/W]׸
  unsigned char masterReadDataMode:1;					// 呕uǂ݋׸(=0͎呕uƓ)
  unsigned char unused:6;
} USI_TWI_state = {0};

//	* USI_TWI֐ *

/*----------------------------------------------------------
 TWI]upUSI
----------------------------------------------------------*/
void USI_TWI_Slave_Initialize( unsigned char TWI_ownAddress )
{
  TWI_slaveAddress = TWI_ownAddress;				// ]uڽ

  PORT_USI |=  (1<<PORT_USI_SCL);					// SCL=Jlw
  PORT_USI |=  (1<<PORT_USI_SDA);					// SDA=Jlw
  DDR_USI  |=  (1<<PORT_USI_SCL);					// SCLo͐ݒ
  DDR_USI  &= ~(1<<PORT_USI_SDA);					// SDA͐ݒ
  USICR    =  (1<<USISIE)|(0<<USIOIE)|				// Jn荞݋,vꊄ荞݋֎~(JnȑǑvꊄ荞݂͐ݓIɎs)
              (1<<USIWM1)|(0<<USIWM0)|				// 2ݒ(vSCLێȂ)
              (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|	// Oۯ㏸[Đݒ
              (0<<USITC);
  USISR    = 0xF0;									// S׸މ(0),vؾ
}

/*----------------------------------------------------------
 USI_TWIޯ̧ɑ΂ݒƎ擾p֐
----------------------------------------------------------*/
unsigned char USI_TWI_Start_Transceiver_With_Data( unsigned char *msg ,unsigned char msgSize )
{
  unsigned char i;

#ifdef BUFFER_CONTROL
  if ( msgSize > TWI_TX_BUFFER_SIZE )		// Mޯ̧ŁA
	return (FALSE);							// sƋɕA
#endif

  if ( !USI_TWI_statusReg.dataInTxBuf )		// Mޯ̧ŁA
  {
	for ( i=0; i<msgSize; i++ )				// Mүނޯ̧֓]
	  TWI_TxBuf[i] = msg[i];				// Ή޲Ăү ޯ̧瑗Mޯ̧֕
	USI_TWI_statusReg.dataInTxBuf = TRUE;	// Mޯ̧ްL׸ސݒ
	return (TRUE);							// ƋɕA
  }
  else										// Mޯ̧cްLŁA
	return (FALSE);							// sƋɕA
}

unsigned char USI_TWI_Get_Data_From_Transceiver( unsigned char *msg ,unsigned char msgSize )
{
  unsigned char i;

#ifdef BUFFER_CONTROL
  if ( msgSize > TWI_RX_BUFFER_SIZE )		// Mޯ̧ŁA
	return (FALSE);							// sƋɕA
#endif

  if ( USI_TWI_statusReg.dataInRxBuf )		// Mޯ̧ްLŁA
  {
	for ( i=0; i<msgSize; i++ )				// Mүނޯ̧֓]
	  msg[i] = TWI_RxBuf[i];				// Ή޲ĂMޯ̧ү ޯ̧֕
	USI_TWI_statusReg.dataInRxBuf = FALSE;	// Mޯ̧ްL׸މ
	return (TRUE);							// ƋɕA
  }
  else										// Mޯ̧ްȂŁA
	return (FALSE);							// sƋɕA
}

// * 荞ݏ *

/*----------------------------------------------------------
 USI_TWIJnoAUSITWIڽ ߹ĎMɏB
----------------------------------------------------------*/
#pragma vector=USI_START_vect
__interrupt void USI_Start_Condition_ISR(void)
{
  USI_TWI_state.addressMode = TRUE;						// TWIڽ ߹ċ׸ސݒ
  DDR_USI &= ~(1<<PORT_USI_SDA);						// SDA͐ݒ
  USICR   =   (1<<USISIE)|(1<<USIOIE)|					// Jnƌv̗荞݋(Jn荞݂͍đJnp)
			  (1<<USIWM1)|(1<<USIWM0)|					// 2ݒ(vꎞSCL=Lێt)
			  (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|		// Oۯ㏸[Đݒ
			  (0<<USITC);
  USISR   =   (1<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// S׸މ(0)
			  (0x0<<USICNT0);							// USIv8ޯĂɐݒ
}

/*----------------------------------------------------------
 SĂ̒ʐM̏BVKJnҋ@֎~܂B
----------------------------------------------------------*/
#pragma vector=USI_OVF_vect
__interrupt void USI_Counter_Overflow_ISR(void)
{
  static volatile unsigned char TWI_bufPtr;

/* ڽR/WޯĂ𒲂ׂđΉ׸ނݒ肵܂BMɑ΂Ăްp\
ǂAMɑ΂Ă͒uꏊ邩ǂɈˑA呕u(ǂ/)ɂ
ėvꂽ̌`ɏ]ꍇɱڽɑ΂ACKŉ܂B*/
  if ( USI_TWI_state.addressMode )									// ڽ ߹ė\ŁA
  {
	/* ڽČĂяo܂͎ȂAvꂽ(R/W)Jn */
	if ( (USIDR == 0) || (( USIDR>>1 ) == TWI_slaveAddress) )		// ČĂяo܂͎ڽŁA
	{
	  TWI_bufPtr = 0;												// ްMɑ΂ޯ̧
	  if (USIDR == 0)												// ČĂяoŁA
	  {
		USI_TWI_statusReg.genAddressCall = TRUE;					// ČĂяo׸ސݒ
	  }
	  else															// ڽŁA
	  {
		USI_TWI_statusReg.genAddressCall = FALSE;					// ČĂяo׸މ
	  }

	  USI_TWI_state.addressMode = FALSE;							// ڽ ߹ ׸މ
	  USI_TWI_state.masterReadDataMode = ( USIDR & 0x01 );			// 呕uǂ/׸ސݒ(=R/Wޯ)
	  USIDR = 0;													// ACKԓ

	  /* 呕uǂݓőMޯ̧ȂANACKԓ̂߁APɊJno֒ڕ */
	  if ( USI_TWI_state.masterReadDataMode )						// 呕uǂݓŁA
	  {
		if ( !USI_TWI_statusReg.dataInTxBuf )						// Mޯ̧ްLŁA
		{
		  USICR = (1<<USISIE)|(0<<USIOIE)|							// Jn荞݋,vꊄ荞݋֎~
				  (1<<USIWM1)|(0<<USIWM0)|							// 2ݒ(vSCLێȂ)
				  (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|				// Oۯ㏸[Đݒ
				  (0<<USITC);
		  USISR = (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// JnoȊȎS׸މ
				  (0x0<<USICNT0);
		  return;
		}
	  }
	  /* 呕uŎMޯ̧ȂANACKԓ̂߁APɊJno֒ڕ */
	  else if ( USI_TWI_statusReg.dataInRxBuf )
	  {
		USICR = (1<<USISIE)|(0<<USIOIE)|							// Jn荞݋,vꊄ荞݋֎~
				(1<<USIWM1)|(0<<USIWM0)|							// 2ݒ(vSCLێȂ)
				(1<<USICS1)|(0<<USICS0)|(0<<USICLK)|				// Oۯ㏸[Đݒ
				(0<<USITC);
		USISR = (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
				(0x0<<USICNT0);
		return;
	  }
	  DDR_USI |=  (1<<PORT_USI_SDA);								// SDAo͐ݒ
	  USISR   =   (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// JnoȊȎS׸މ
				  (0xE<<USICNT0);									// USIv1ޯĂɐݒ
	  while ( !(USISR & ( (1<<USICIF)|(1<<USIOIF) )) );				// ACKoҋ@(܂͊JnoŔo)
	  DDR_USI &=  ~(1<<PORT_USI_SDA);								// SDA͐ݒ
	}

	/* ڽČĂяo܂͎łȂΖ߹āÅJnҋ@ */
	else															// ڽČĂяo܂͎łȂȂA
	{
	  USICR = (1<<USISIE)|(0<<USIOIE)|								// Jn荞݋,vꊄ荞݋֎~
			  (1<<USIWM1)|(0<<USIWM0)|								// 2ݒ(vSCLێȂ)
			  (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|					// Oۯ㏸[Đݒ
			  (0<<USITC);
	  USISR = (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
			  (0x0<<USICNT0);
	  return;
	}
  }

  /* ް ߹Ăłް ޲ēǂ/(N)ACK̏ */
  else																// ް ߹ċԂŁA
  {
	/* ]uɂ鉽޲Ă̑M(呕uǂ)BMIȂNACKApȂACKǂ݂܂B */
	if ( USI_TWI_state.masterReadDataMode )							// 呕uǂݓŁA
	{
	  DDR_USI &= ~(1<<PORT_USI_SDA);								// SDA͐ݒ
	  USIDR   =  0;													// ACKl
	  USISR   =  (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
				 (0xE<<USICNT0);									// USIv1ޯĂɐݒ
	  while ( !(USISR & ( (1<<USICIF)|(1<<USIOIF) )) );				// (N)ACKMҋ@(܂͊JnoŔo)
	  if ( USIDR )													// NACKM(USIDRLSB=1)ŁA
	  {																// Jno
		USI_TWI_statusReg.dataInTxBuf = FALSE;						// Mޯ̧ްL׸މ
		USICR = (1<<USISIE)|(0<<USIOIE)|							// Jn荞݋,vꊄ荞݋֎~
				(1<<USIWM1)|(0<<USIWM0)|							// 2ݒ(vSCLێȂ)
				(1<<USICS1)|(0<<USICS0)|(0<<USICLK)|				// Oۯ㏸[Đݒ
				(0<<USITC);
		USISR = (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
				(0x0<<USICNT0);
		return;
	  }

#ifdef BUFFER_CONTROL
	  /* 呕u(ACK𑗏o)Mޯ̧eʂzėvꍇA׸ނݒ肵ďI܂B */
	  else															// ACKM(USIDRLSB=0)ŁA
	  {
		if ( TWI_bufPtr == TWI_TX_BUFFER_SIZE )						// Mޯ̧ްMς݂ŁA
		{
		  USI_TWI_statusReg.TxBufOverflow = TRUE;					// Mޯ̧׸ސݒ
		  // Jno҂ݒ
		  USICR = (1<<USISIE)|(0<<USIOIE)|							// Jn荞݋,vꊄ荞݋֎~
				  (1<<USIWM1)|(0<<USIWM0)|							// 2ݒ(vSCLێȂ)
				  (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|				// Oۯ㏸[Đݒ
				  (0<<USITC);
		  USISR = (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|	// JnoȊȎS׸މ
				  (0x0<<USICNT0);
		  return;
		}
	  }
#endif
	}

	/* 呕u(]uM)BMްi[Ǝ呕uւACKoB */
	else															// 呕uŁA
	{
	  TWI_RxBuf[TWI_bufPtr++] = USIDR;								// MްMޯ̧֊i[,ʒuwqis
	  USIDR = 0;													// ACKlݒ(o)

#ifdef BUFFER_CONTROL
	  if ( TWI_bufPtr == TWI_RX_BUFFER_SIZE )						// Mޯ̧ŁA
	  {
		USI_TWI_statusReg.RxBufOverflow = TRUE;						// Mޯ̧׸ސݒ
		USIDR = 0x80;												// NACKlݒ(o)
	  }
#endif
	  DDR_USI |= (1<<PORT_USI_SDA);									// SDAo͐ݒ
	  USISR   =  (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
				 (0xE<<USICNT0);									// USIv1ޯĂɐݒ
	  while ( !(USISR & ( (1<<USICIF)|(1<<USIOIF) )) );				// (N)ACKoҋ@(܂͊JnoŔo)
	  DDR_USI &= ~(1<<PORT_USI_SDA);								// SDA͐ݒ
	}
  }

  /* 呕uްǂݍ(]uM)JnȂAMޯ̧USIDRްʁB */
  if ( USI_TWI_state.masterReadDataMode )							// 呕uǂݓŁA
  {
	USIDR   =  TWI_TxBuf[TWI_bufPtr++];								// Mޯ̧̑Ή޲ĂUSIDR,ʒuwqis
	DDR_USI |= (1<<PORT_USI_SDA);									// SDAo͐ݒ
	USISR   =  (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
			   (0x0<<USICNT0);										// USIv8ޯĂɐݒ
  }

  /* 呕uAް ޲ĎM(܂͒~o)̏ */
  else																// 呕uŁA
  {
//	DDR_USI &=  ~(1<<PORT_USI_SDA);									// SDA͐ݒ
	USISR = (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|			// JnoȊȎS׸މ
			(0xE<<USICNT0);											// USIv1ޯĂɐݒ
	while ( !(USISR & ( (1<<USICIF)|(1<<USIOIF)|(1<<USIPF) )) );	// 1ޯĎM܂͒~ҋ@(܂͊JnoŔo)

	if ( USISR & (1<<USIPF) )										// ~oŁA
	{																// 呕uIȂ̂ŁA
	  USI_TWI_statusReg.dataInRxBuf = TRUE;							// Mޯ̧ްL׸ސݒ
	  // Jno҂ݒ
	  USICR = (1<<USISIE)|(0<<USIOIE)|								// Jn荞݋,vꊄ荞݋֎~
			  (1<<USIWM1)|(0<<USIWM0)|								// 2ݒ(vSCLێȂ)
			  (1<<USICS1)|(0<<USICS0)|(0<<USICLK)|					// Oۯ㏸[Đݒ
			  (0<<USITC);
	  USISR = (0<<USICIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
			  (0x0<<USICNT0);
	  return;
	}
	else															// 1ޯĎMŁA
	{
	  USISR = (0<<USICIF)|(1<<USIOIF)|(0<<USIPF)|(1<<USIDC)|		// JnoȊȎS׸މ
              (0x2<<USICNT0);										// USIv(c)7ޯĂɐݒ
	}
  }
}
